package com.steerinfo.meterwork.meterworkcarnoidentify.controller;

import cn.hutool.db.Page;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.meterworkcarmetertime.model.GroupTimeVo;
import com.steerinfo.meterwork.meterworkcarmetertime.model.PointDetailsBo;
import com.steerinfo.meterwork.meterworkcarnoidentify.model.GroupByNumVo;
import com.steerinfo.meterwork.meterworkcarnoidentify.model.MeterWorkCarnoIdentify;
import com.steerinfo.meterwork.meterworkcarnoidentify.model.PointDetailsVo;
import com.steerinfo.meterwork.meterworkcarnoidentify.service.IMeterWorkCarnoIdentifyService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterWorkCarnoIdentify RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-10-12 04:48
 * 类描述
 * 修订历史：
 * 日期：2022-10-12
 * 作者：generator
 * 参考：
 * 描述：MeterWorkCarnoIdentify RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkcarnoidentifys")
public class MeterWorkCarnoIdentifyController extends BaseRESTfulController {

    @Autowired
    IMeterWorkCarnoIdentifyService meterWorkCarnoIdentifyService;


    @PostMapping(value = "/getGroupByNum")
    public RESTfulResult getGroupByNum(@RequestBody(required = false) HashMap meterWorkCarnoIdentify){
        try {
            List<GroupByNumVo> groupByNum = meterWorkCarnoIdentifyService.getGroupByNum(meterWorkCarnoIdentify);
            return success(groupByNum);
        }catch (Exception e){
            e.printStackTrace();
            return success(null,"操作失败");
        }
    }

    @ApiOperation(value = "汽车衡车号自动识别统计查询分析--汇总", notes = "根据开始时间、结束时间、站点查询")
    @PostMapping(value = "/getGroupByCarNoNum")
    public RESTfulResult getGroupByCarNoNum(@RequestBody(required = false) HashMap params){
        try {
            List<HashMap> groupByNum = meterWorkCarnoIdentifyService.getGroupByCarNoNum(params);
            return success(groupByNum);
        }catch (Exception e){
            e.printStackTrace();
            return success(null,"操作失败");
        }
    }

    @ApiOperation(value = "汽车衡车号自动识别统计查询分析--明细", notes = "根据开始时间、结束时间、站点查询")
    @PostMapping(value = "/getCarNoDetail")
    public RESTfulResult getCarNoDetail(@RequestBody(required = false) HashMap params){
        try {
            PageList<HashMap> groupByNum = meterWorkCarnoIdentifyService.getCarNoDetail(params);
            return success(groupByNum);
        }catch (Exception e){
            e.printStackTrace();
            return success(null,"操作失败");
        }
    }

    @PostMapping(value = "/getPointDetails")
    public RESTfulResult getPointDetails(@RequestBody(required = false) PointDetailsBo pointDetailsBo){
        try {
            if(pointDetailsBo==null||
                    (pointDetailsBo.getBaseSpotName()==null||
                            "".equals(pointDetailsBo.getBaseSpotName()))&&
                            (pointDetailsBo.getBaseSpotNo()==null||
                                    "".equals(pointDetailsBo.getBaseSpotNo()))){
                return failed("参数错误：请传入计量点参数");
            }
            //分页功能
            PageHelper.startPage(pointDetailsBo.getPageNum(),pointDetailsBo.getPageSize());
            List<PointDetailsVo> pointDetails = meterWorkCarnoIdentifyService.getPointDetails(pointDetailsBo);
            PageList<PointDetailsVo> pageList=new PageList<>(pointDetails);
            return success(pageList);
        }catch (Exception e){
            e.printStackTrace();
            return failed("操作失败");
        }
    }

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkcarnoidentify:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkCarnoIdentify> list = meterWorkCarnoIdentifyService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkcarnoidentify:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkCarnoIdentify> list = meterWorkCarnoIdentifyService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="创建", notes="根据MeterWorkCarnoIdentify对象创建")
    @ApiImplicitParam(name = "meterWorkCarnoIdentify", value = "详细实体meterWorkCarnoIdentify", required = true, dataType = "MeterWorkCarnoIdentify")
    //@RequiresPermissions("meterworkcarnoidentify:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkCarnoIdentify model){
        MeterWorkCarnoIdentify meterWorkCarnoIdentify = meterWorkCarnoIdentifyService.add(model);
        return success("1");
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkcarnoidentify:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkCarnoIdentify meterWorkCarnoIdentify = meterWorkCarnoIdentifyService.getById(id);
        return success(meterWorkCarnoIdentify);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkCarnoIdentify信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkCarnoIdentify", value = "详细实体meterWorkCarnoIdentify", required = true, dataType = "MeterWorkCarnoIdentify")
    })
    //@RequiresPermissions("meterworkcarnoidentify:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkCarnoIdentify model){
        model.setId(id);
        MeterWorkCarnoIdentify meterWorkCarnoIdentify = meterWorkCarnoIdentifyService.modify(model);
        return success(meterWorkCarnoIdentify);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkcarnoidentify:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkCarnoIdentifyService.delete(ids);
    	}
      return success();
    }
}
